// McfSerializer.h: interface for the McfSerializer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MCFSERIALIZER_H__4FB873BD_3411_4F58_9E68_3003DB714396__INCLUDED_)
#define AFX_MCFSERIALIZER_H__4FB873BD_3411_4F58_9E68_3003DB714396__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



class McfSerializer  
{

	
		CArchive*	m_pcaArchive;
		CMemFile 	m_cmfDataFile;
		BYTE*	m_pbyBuffer;
		bool	m_bValid;
public:
	McfSerializer( const  VARIANT& vtData_i );
	McfSerializer();

	bool IsValid();
    operator << ( char cVal_i );
	operator << ( unsigned char ucVal_i );
	operator << ( short sVal_i );
	operator << ( unsigned short usVal_i );
	operator << ( int nVal_i );
	operator << ( unsigned int uVal_i );
	operator << ( long lVal_i );
	operator << ( unsigned long ulVal_i );
	operator << ( float fVal_i );
	operator << ( double dVal_i );
	operator << ( bool bVal_i );
	operator << ( const CString& csVal_i );
	operator << ( CObject& Object_i );
	operator >> ( char& cVal_o );
	operator >> ( unsigned char& ucVal_o );
	operator >> ( short& sVal_o );
	operator >> ( unsigned short& usVal_o );
	operator >> ( int& nVal_o );
	operator >> ( unsigned int& uVal_o );
	operator >> ( long& lVal_o );
	operator >> ( unsigned long& ulVal_o );
	operator >> ( float& fVal_o );
	operator >> ( double& dVal_o );
	operator >> ( bool& bVal_o );
	operator >> ( CString& csVal_o );
	operator >> ( CObject& Object_o );

	bool GetVariant( VARIANT& vtData_o );
	virtual ~McfSerializer();


};

#endif // !defined(AFX_MCFSERIALIZER_H__4FB873BD_3411_4F58_9E68_3003DB714396__INCLUDED_)
